#from future import standard_library
#standard_library.install_aliases()
#from builtins import range
#from builtins import object
import pickle as pickle
import time
import numpy as np


NONE = 0x0
NORM = 0x1
BG   = 0x2

class RefData(object):
    """ Data type for reference information - background and normalization values
        
    """
    def __init__(self,xsize=1,ysize=1, data=None, name=None, timestamp=None, exposure=0, style=NONE, mask=None):

        self.timestamp = timestamp if timestamp else time.asctime()
        self.name = name if name else self.timestamp
        self.style = style
        self.exposure = exposure
        if data is not None:
            self.data = np.array([
                [data[i][j] for j in range(len(data[0]))] for i in range(len(data))
            ], dtype=float)			 
        elif self.style==NORM :
            self.data = np.array([[1 for j in range(ysize)] for i in range(xsize)], dtype=float)
        else :
            self.data = np.array([[0 for j in range(ysize)] for i in range(xsize)], dtype=float)
        self.xsize = len(self.data)
        self.ysize = len(self.data[0])
        
        if self.style==NORM:
            self.mask = (
                np.array([ [mask[i][j] for j in range(len(mask[0]))] for i in range(len(mask)) ], dtype=float)
                if mask is not None
                else np.array([[1 for j in range(ysize)] for i in range(xsize)], dtype=float)
            )	 

    def save (self, file, protocol=None):
        """ Save data """
        pickler = pickle.Pickler(file, protocol = protocol)
        pickler.dump(self.name)
        pickler.dump(self.timestamp)
        pickler.dump(self.exposure)
        pickler.dump(self.style)
        pickler.dump(self.xsize)
        pickler.dump(self.ysize)
        pickler.dump(self.data)
        if self.style == NORM :
           pickler.dump(self.mask)

    def load (self, file):
        """ Load data """
        pickler = pickle.Unpickler(file,fix_imports=True,encoding="latin-1")
        self.name = pickler.load()
        self.timestamp = pickler.load()
        self.exposure = pickler.load()
        self.style = pickler.load()
        self.xsize = pickler.load()
        self.ysize = pickler.load()
        self.data = np.array(pickler.load())
        if self.style == NORM :
            self.mask = np.array(pickler.load())
